<?php
class ScreenshotUploader {

	private $settingsManager = null;
	private $newImagefilename;
	private $newThumbnailFilename;


	public function ScreenshotUploader() {
		include_once dirname(__FILE__) . "/../constants.php";
		include_once Constants :: getFunctionsFolder() . "functions.watermark.php";
		include_once Constants :: getClassFolder() . "SettingsManager.php";
		$this->settingsManager =new SettingsManager();
	}

	public function getNewImagefilename() {
		return $this->newImagefilename;
	}

	public function getNewThumbnailFilename() {
		return $this->newThumbnailFilename;
	}
	
	public function uploadFile($filename) {
		$upload_image = $this->uploadImage($filename);
		if (is_array($upload_image)) {
			foreach ($upload_image as $key => $value) {
				if ($value == "-ERROR-") {
					unset ($upload_image[$key]);
				}
			}
			$document = array_values($upload_image);
			for ($x = 0; $x < sizeof($document); $x++) {
				$errorList[] = $document[$x];
			}
			$imgUploaded = false;
		} else {
			$imgUploaded = true;
		}

		if ($imgUploaded) {
			echo "upload successfull!";
		} else {
			echo 'Error(s) Found: ';
			foreach ($errorList as $value) {
				echo $value . ', ';
			}
		}
	}

	private function isWatermark() {
		return $this->settingsManager->getPropertyValue(TEXTENABLED);
	}
	private function isWatermarkThumbnail() {
		return $this->settingsManager->getPropertyValue(THUMBNAIL);
	}
	private function isWatermarkResize() {
		return $this->settingsManager->getPropertyValue(RESIZETHUMBNAIL);
	}

	private function watermark(& $image) {
		global $settingsManager;
		if ($this->isWatermark()) {
			$textenable = $this->settingsManager->getPropertyValue(TEXTENABLED);
			$text = $this->settingsManager->getPropertyValue(TEXT);
			$fontsize = $this->settingsManager->getPropertyValue(FONTSIZE);
			$textborder = $this->settingsManager->getPropertyValue(TEXTBORDER);
			$align = $this->settingsManager->getPropertyValue(ALIGN);
			$valign = $this->settingsManager->getPropertyValue(VALIGN);
			$fontstyle = $this->settingsManager->getPropertyValue(FONTSTYLE);
			$red = $this->settingsManager->getPropertyValue(RED);
			$green = $this->settingsManager->getPropertyValue(GREEN);
			$blue = $this->settingsManager->getPropertyValue(BLUE);
			$color = ImageColorAllocate($image, $red, $green, $blue);
			$fontfile = "fonts/" . $fontstyle;
			imagestringbox($image, $fontsize, $fontfile, $textborder, $align, $valign, $text, $color);
		}
	}

	private function saveImage($image, $filetype, $imageSavePath, & $errorList) {
		switch ($filetype) {
			case "gif" :
				if (!@ imagegif($image, $imageSavePath)) {
					$errorList[] = "PERMISSION DENIED [GIF]";
				}
				break;
			case "jpg" :
				if (!@ imagejpeg($image, $imageSavePath, 70)) {
					$errorList[] = "PERMISSION DENIED [JPG]";
				}
				break;
			case "jpeg" :
				if (!@ imagejpeg($image, $imageSavePath, 70)) {
					$errorList[] = "PERMISSION DENIED [JPEG]";
				}
				break;
			case "png" :
				if (!@ imagepng($image, $imageSavePath, 0)) {
					$errorList[] = "PERMISSION DENIED [PNG]";
				}
				break;
		}
	}

	private function loadImage($filetype, $filePath) {
		switch ($filetype) {
			case "gif" :
				$image = @ imagecreatefromgif($filePath);
				break;
			case "jpg" :
				$image = @ imagecreatefromjpeg($filePath);
				break;
			case "jpeg" :
				$image = @ imagecreatefromjpeg($filePath);
				break;
			case "png" :
				$image = @ imagecreatefrompng($filePath);
				break;
		}
		return $image;
	}

	public function createThumbnail($image) {
		$maxW = Constants :: getThumbnaiWith();
		$width_orig = imagesx($image);
		$height_orig = imagesy($image);

		if ($width_orig < $maxW) {
			$fwidth = $width_orig;
		} else {
			$fwidth = $maxW;
		}
		$ratio_orig = $width_orig / $height_orig;
		$fheight = $fwidth / $ratio_orig;

		$top_offset = 0;
		$image_p = imagecreatetruecolor($fwidth, $fheight);
		$white = imagecolorallocate($image_p, 255, 255, 255);
		imagefill($image_p, 0, 0, $white);

		if ($this->isWatermark() && $this->isWatermarkThumbnail() && $this->isWatermarkResize()) {
			$this->watermark($image);
		}
		@ imagecopyresampled($image_p, $image, 0, $top_offset, 0, 0, $fwidth, $fheight, $width_orig, $height_orig);
		if ($this->isWatermark() && $this->isWatermarkThumbnail() && !$this->isWatermarkResize()) {
			$this->watermark($image_p);
		}
		return $image_p;

	}
	private function uploadImage($fileName) {
		$maxSize = 99999999999;
		$fullPath = '../screenshots/';
		$relPath = $fullPath;

		$folder = $relPath;
		$maxlimit = $maxSize;
		$allowed_ext = "jpg,jpeg,gif,png,bmp";
		$match = "";
		$filesize = $_FILES[$fileName]['size'];
		echo "|".$fileName."|".$filesize."|";
		if ($filesize > 0) {
			$filename = strtolower($_FILES[$fileName]['name']);
			$filename = preg_replace('/\s/', '_', $filename);
			if ($filesize < 1) {
				$errorList[] = "File size is empty.";
			}
			if ($filesize > $maxlimit) {
				$errorList[] = "File size is too big.";
			}
			if (count($errorList) < 1) {
				$file_ext = preg_split("/\./", $filename);
				$allowed_ext = preg_split("/\,/", $allowed_ext);
				foreach ($allowed_ext as $ext) {
					if ($ext == end($file_ext)) {
						$match = "1"; // File is allowed
						$NUM = time();
						$front_name = substr($file_ext[0], 0, 15);
						$newImagefilename = $front_name . "_" . $NUM . "." . end($file_ext);
						$newThumbnailFilename = "thumb_" . $newImagefilename;
						$filetype = end($file_ext);
						$imageSave = $folder . $newImagefilename;
						$thumbnailSave = $folder . $newThumbnailFilename;
						if ((!file_exists($imageSave)) && (!file_exists($thumbnailSave))) {

							$image = $this->loadImage($filetype, $_FILES[$fileName]['tmp_name']);

							$imageThumbnail = $this->createThumbnail($image);

							$this->saveImage($imageThumbnail, $filetype, $thumbnailSave, & $errorList);

							if ($this->isWatermark()) {
								if (!$this->isWatermarkThumbnail() || !$this->isWatermarkResize()) {
									$this->watermark($image);
								}
								$this->saveImage($image, $filetype, $imageSave, & $errorList);
							} else {
								if (!move_uploaded_file($_FILES[$fileName]['tmp_name'], $imageSave)) {
									$errorList[] = "error moving";
								}
							}
							imageDestroy($image);
							@ imagedestroy($filename);
						} else {
							$errorList[] = "CANNOT MAKE IMAGE IT ALREADY EXISTS";
						}
					}
				}
			}
		} else {
			$errorList[] = "NO FILE SELECTED";
		}
		if (!$match) {
			$errorList[] = "File type isn't allowed: $filename";
		}

		$this->newImagefilename=$newImagefilename;
		$this->newThumbnailFilename=$newThumbnailFilename;

		if (sizeof($errorList) == 0) {
			return "succes";
		} else {
			$eMessage = array ();
			for ($x = 0; $x < sizeof($errorList); $x++) {
				$eMessage[] = $errorList[$x];
			}
			return $eMessage;
		}
	}

}
?>